{Unit file for THotAnimFX simple project. This unit displays
a TForm with a single THotAnimFX loaded with a background
and sprite bitmap. When the form first shows or when the
component is clicked, an effect and an animation occur in
sequence.

Last revision: May 05, 1998.

Source code for THotAnimFX is copyright 1997, 1998 by
Acro Technology Inc. All rights reserved. This unit has
no such copyright.
}

unit HASimple;

interface

uses
{$ifdef WIN32}
	Windows,
{$else}
	WinTypes, WinProcs,
{$endif}
	SysUtils, Messages, Classes, Graphics, Controls, Forms, Dialogs, HotAn104;

type
  TForm1 = class(TForm)
    HotAnimFX1: THotAnimFX;
    procedure HotAnimFX1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure HotAnimFX1HotspotClick(Sender: TObject;
      const HotspotName: String);
    procedure HotAnimFX1AnimMove(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
	HotAnimFX1Click(Sender);
end;

procedure TForm1.HotAnimFX1Click(Sender: TObject);
begin
	with HotAnimFX1 do
	begin
		if Busy then		{Important! Don't allow user-recursive re-entry!}
			exit;

{$ifdef VER100}
		LoadSpriteFromFile('..\MakeDLL\Bttrfly.bmp');
		LoadBitmapFromFile('..\MakeDLL\AcroLogo.bmp');		{Sidestep Delphi 3 color distortion by loading at run-time}
{$endif}

		ClearSprite;
		ShowEffect;
		while Busy do		{Important! Allows effect to finish.}
			Application.ProcessMessages;

		StartAnim;
	end;
end;

procedure TForm1.HotAnimFX1HotspotClick(Sender: TObject; const HotspotName: String);
begin
	if HotspotName = 'Acro' then
		ShowMessage('You touched Acro!');
end;

procedure TForm1.HotAnimFX1AnimMove(Sender: TObject);
begin
	Caption := HotAnimFX1.SpriteLocation;
end;

end.
