unit FxApp1;

{An example form to illustrate the use of TDBImageFX for effect
display of bitmaps stored in a database.

This example code is copyright 1997, 1998 Acro Technology Inc. and can
be freely used by any purchaser of TImageFX but may not be sold nor
distributed in any way.}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, DB, DBTables, StdCtrls, ExtCtrls, DBCtrls,
	ImgFX312, IfxDB312;

type
	TForm1 = class(TForm)
    DataSource1: TDataSource;
		Table1: TTable;
    DBImageFX1: TDBImageFX;
    DBNavigator1: TDBNavigator;
    Button1: TButton;
		procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
  private
		CancelLoop: Boolean;
	public
	end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
const
	ShowAll = 'Show all';
begin
	CancelLoop := False;
	DBImageFX1.Effect := fxNone;	{Start over}
	DBNavigator1.Enabled := False;		{Don't allow any re-entrant stuff}

	if Button1.Caption = ShowAll then
	begin
		Button1.Caption := 'Stop';

		try
			while (not CancelLoop) and (DBImageFX1.Effect <= fxBlindVert) do	{Can use High(DBImageFX1.Effect) in D2/D3}
			begin
				if Table1.EOF then
					Table1.First
				else
					Table1.Next;

				while DBImageFX1.Busy do		{Important! Allows effect to finish before continuing execution}
					Application.ProcessMessages;

				if (DBImageFX1.Effect < fxBlindVert) then
					DBImageFX1.Effect := Succ(DBImageFX1.Effect)		{Go to next effect}
				else
					DBImageFX1.Effect := fxNone;
			end;
		finally
			Button1.Caption := ShowAll;		{Reset for next click}
			DBNavigator1.Enabled := True;
		end;
	end else
	begin
		FormCloseQuery(Self, CancelLoop);		{CancelLoop is just a placeholder so FormCloseQuery can be called}
		Button1.Caption := ShowAll;
	end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
	CancelLoop := True;
	with DBImageFX1 do
	begin
		StopEffect;
		Invalidate;
	end;
end;

procedure TForm1.DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
begin
	with DBImageFX1 do
	begin
		case Button of
			nbNext:
			begin
				if (Effect = fxBlindVert) then		{If end of effects reached, loop to other end}
					Effect := fxNone
				else
					Effect := Succ(Effect)		{Go to next effect}
			end;

			nbPrior:
			begin
				if (Effect = fxNone) then
					Effect := fxBlindVert
				else
					Effect := Pred(Effect);		{Go to prior effect}
			end;

			nbFirst: Effect := fxNone;

			nbLast: Effect := fxBlindVert;

			{else}
		end;
	end;
end;

end.
