{This is a screen saver starter example. It does not have any hooks
into the Windows screen saver functions but it shows how to
successively display bitmaps with effects and have the screen go
away when the mouse moves.

To close the app:

in Win95: Press Show All so effects are displayed. While they are
showing, move the mouse over TImageFX to minimize, then right click
on the task bar button and Close.

in Win3.1: I forget how to close a minimized app in Win3...

This example code is copyright 1997, 1998 Acro Technology Inc. and can
be freely used by any purchaser of TImageFX but may not be sold nor
distributed in any way.
}

unit LoopEffs;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, StdCtrls, ImgFX312;

const
	ShowAll = 'Show all';

type
  TForm2 = class(TForm)
		Button1: TButton;
    Button2: TButton;
    ImageFX1: TImageFX;
    procedure Button1Click(Sender: TObject);
		procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);
    procedure ImageFX1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
		procedure Button2Click(Sender: TObject);
  private
		CancelLoop: Boolean;
		ToggleBitmap: Boolean;
		procedure HaltLoop;
	public
		{ Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

uses FxApp1;

{This loops 2 bitmaps through all effects then quits}
procedure TForm2.Button1Click(Sender: TObject);
begin
	CancelLoop := False;
	ImageFX1.Effect := fxNone;	{Start over}

	if Button1.Caption = ShowAll then
	begin
		Button1.Caption := 'Stop';

		try
			while (not CancelLoop) and (ImageFX1.Effect < fxBlindVert) do	{Can use High(ImageFX1.Effect) in D2/D3}
			begin
				if ToggleBitmap then
					ImageFX1.LoadFromFile('..\Bmps\Earth.bmp')
				else
					ImageFX1.LoadFromFile('..\Bmps\Shipping.bmp');
				ToggleBitmap := not ToggleBitmap;		{Set for next picture}
				ImageFX1.ShowEffect;

				while ImageFX1.Busy do		{Important! Allows effect to finish before continuing execution}
					Application.ProcessMessages;

				ImageFX1.Effect := Succ(ImageFX1.Effect);		{Go to next [Successive] effect}
			end;
		finally
			Button1.Caption := ShowAll;		{Reset for next click}
		end;
	end else
	begin
		FormCloseQuery(Self, CancelLoop);		{CancelLoop is just a placeholder so FormCloseQuery can be called}
		Button1.Caption := ShowAll;
	end;
end;

{On opening, send a mouse click to the button to get things started}
procedure TForm2.FormShow(Sender: TObject);
begin
	PostMessage(Button1.Handle, WM_LBUTTONDOWN, 0, 0);
	PostMessage(Button1.Handle, WM_LBUTTONUP, 0, 0);
end;

{This procedure minimizes the form when the mouse moves over ImageFX1. It may be better to have this code in
a MouseMove event for the form itself.}
procedure TForm2.ImageFX1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
	if ImageFX1.Busy then
	begin
		ShowMessage('About to minimize');
		FormCloseQuery(Self, CancelLoop);		{CancelLoop is just a placeholder so FormCloseQuery can be called}
		Button1.Caption := ShowAll;
		Application.Minimize;
	end;
end;

procedure TForm2.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
	HaltLoop;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
	HaltLoop;
	Form1.ShowModal;
end;

procedure TForm2.HaltLoop;
begin
	CancelLoop := True;
	ImageFX1.StopEffect;
	ImageFX1.Invalidate;
	Button1.Caption := ShowAll;
end;

end.
